Index: trunk/IPs/systemC/processor/Morpheo/Files/Instance_debug.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Files/Instance_debug.cfg	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Files/Instance_debug.cfg	(revision 114)
@@ -1,12 +1,12 @@
 <?xml version="1.0" encoding="ISO-8859-1" ?>
 
-<core name="Instance_debug">
+<core name="Instance_min">
 
   <thread id="0">             
-    <parameter name="size_ifetch_queue"                     value="32" />
-    <parameter name="nb_inst_fetch"                         value="8" />
-    <parameter name="ras_size_queue"                        value="8" />
-    <parameter name="upt_size_queue"                        value="8" />
-    <parameter name="ufpt_size_queue"                       value="4" />
+    <parameter name="size_ifetch_queue"                     value="1" />
+    <parameter name="nb_inst_fetch"                         value="1" />
+    <parameter name="ras_size_queue"                        value="2" />
+    <parameter name="upt_size_queue"                        value="1" />
+    <parameter name="ufpt_size_queue"                       value="1" />
 
     <group id="0">
@@ -16,7 +16,7 @@
                                                             
   <decod_bloc id="0">                                       
-    <parameter name="size_decod_queue"                      value="16"/>
-    <parameter name="decod_queue_scheme"                    value="1" />
-    <parameter name="nb_inst_decod"                         value="4" />
+    <parameter name="size_decod_queue"                      value="1" />
+    <parameter name="decod_queue_scheme"                    value="0" />
+    <parameter name="nb_inst_decod"                         value="1" />
     <parameter name="nb_context_select"                     value="1" />
     <parameter name="context_select_priority"               value="1" />
@@ -25,32 +25,32 @@
                                                             
   <rename_bloc id="0">                                      
-    <parameter name="nb_inst_insert"                        value="4" />
-    <parameter name="nb_inst_retire"                        value="4" />
+    <parameter name="nb_inst_insert"                        value="1" />
+    <parameter name="nb_inst_retire"                        value="1" />
     <parameter name="rename_select_priority"                value="1" />
     <parameter name="rename_select_load_balancing"          value="1" />
     <parameter name="rename_select_nb_front_end_select"     value="1" />
-    <parameter name="nb_general_register"                   value="256"/>
-    <parameter name="nb_special_register"                   value="128" />
-    <parameter name="nb_reg_free"                           value="8" />
-    <parameter name="nb_rename_unit_bank"                   value="8" />
+    <parameter name="nb_general_register"                   value="64"/>
+    <parameter name="nb_special_register"                   value="4" />
+    <parameter name="nb_reg_free"                           value="1" />
+    <parameter name="nb_rename_unit_bank"                   value="1" />
   </rename_bloc>                                            
                                                             
-  <read_bloc id="0,1,2,3">                                        
-    <parameter name="size_read_queue"                       value="4" />
-    <parameter name="size_reservation_station"              value="4" />
+  <read_bloc id="0">                                        
+    <parameter name="size_read_queue"                       value="1" />
+    <parameter name="size_reservation_station"              value="1" />
     <parameter name="nb_inst_retire_reservation_station"    value="1" />
   </read_bloc>                                              
-
-  <write_bloc id="0,1,2,3,4,5,6">                                       
-    <parameter name="size_write_queue"                      value="4" />
-    <parameter name="size_execute_queue"                    value="4" />
+                                                            
+  <write_bloc id="0">                                       
+    <parameter name="size_write_queue"                      value="1" />
+    <parameter name="size_execute_queue"                    value="1" />
     <parameter name="nb_bypass_write"                       value="0" />
   </write_bloc>                                             
-
+                                                            
   <load_store_unit id="0">                                  
-    <parameter name="size_store_queue"                      value="16" />
-    <parameter name="size_load_queue"                       value="8" />
-    <parameter name="size_speculative_access_queue"         value="4" />
-    <parameter name="nb_port_check"                         value="4" />
+    <parameter name="size_store_queue"                      value="2" />
+    <parameter name="size_load_queue"                       value="1" />
+    <parameter name="size_speculative_access_queue"         value="1" />
+    <parameter name="nb_port_check"                         value="1" />
     <parameter name="speculative_load"                      value="2" />
     <parameter name="nb_bypass_memory"                      value="0" />
@@ -59,5 +59,5 @@
   </load_store_unit>
 
-  <functionnal_unit id="0,1" >
+  <functionnal_unit id="0">
     <parameter name="nb_inst_functionnal_unit" value="1" />
 
@@ -69,9 +69,4 @@
     <timing type="6"  latence="1" delay="1" />
     <timing type="7"  latence="1" delay="1" />
-  </functionnal_unit>
-
-  <functionnal_unit id="2">
-    <parameter name="nb_inst_functionnal_unit" value="1" />
-
     <timing type="8"  latence="1" delay="1" />
     <timing type="10" latence="1" delay="1" />
@@ -83,55 +78,44 @@
     <parameter name="nb_inst_branch_decod"                  value="1" />
     <parameter name="nb_inst_branch_update"                 value="1" />
-    <parameter name="btb_size_queue"                        value="256" />
-    <parameter name="btb_associativity"                     value="8" />
+    <parameter name="btb_size_queue"                        value="1" />
+    <parameter name="btb_associativity"                     value="1" />
     <parameter name="btb_size_counter"                      value="2" />
-    <parameter name="btb_victim_scheme"                     value="3" />
-    <parameter name="dir_predictor_scheme"                  value="4" />
+    <parameter name="btb_victim_scheme"                     value="1" />
+    <parameter name="dir_predictor_scheme"                  value="1" />
                                                             
     <predictor id="0">                                      
-      <parameter name="dir_have_bht"                        value="0"  />
-      <parameter name="dir_bht_size_shifter"                value="1"  />
-      <parameter name="dir_bht_nb_shifter"                  value="64" />
-      <parameter name="dir_have_pht"                        value="1"  />
-      <parameter name="dir_pht_size_counter"                value="2"  />
-      <parameter name="dir_pht_nb_counter"                  value="16" />
-      <parameter name="dir_pht_size_address_share"          value="0"  />
+      <parameter name="dir_have_bht"                        value="0" />
+      <parameter name="dir_have_pht"                        value="0" />
     </predictor>                                            
+                                                            
     <predictor id="1">                                      
-      <parameter name="dir_have_bht"                        value="1" />
-      <parameter name="dir_bht_size_shifter"                value="4" />
-      <parameter name="dir_bht_nb_shifter"                  value="1" />
-      <parameter name="dir_have_pht"                        value="1" />
-      <parameter name="dir_pht_size_counter"                value="2" />
-      <parameter name="dir_pht_nb_counter"                  value="64" />
-      <parameter name="dir_pht_size_address_share"          value="0" />
+      <parameter name="dir_have_bht"                        value="0" />
+      <parameter name="dir_have_pht"                        value="0" />
     </predictor>                                            
+                                                            
     <predictor id="2">                                      
       <parameter name="dir_have_bht"                        value="0" />
-      <parameter name="dir_have_pht"                        value="1" />
-      <parameter name="dir_pht_size_counter"                value="2" />
-      <parameter name="dir_pht_nb_counter"                  value="128" />
-      <parameter name="dir_pht_size_address_share"          value="0" />
-    </predictor>                                            
+      <parameter name="dir_have_pht"                        value="0" />
+    </predictor>
   </front_end>
 
   <ooo_engine id="0">
     <parameter name="nb_rename_unit"                        value="1" />
-    <parameter name="nb_inst_issue"                         value="4" />
+    <parameter name="nb_inst_issue"                         value="1" />
     <parameter name="nb_inst_reexecute"                     value="1" />
-    <parameter name="nb_inst_commit"                        value="4" />
+    <parameter name="nb_inst_commit"                        value="1" />
     <parameter name="nb_inst_branch_complete"               value="1" />
     <parameter name="nb_rename_unit_select"                 value="1" />
     <parameter name="nb_execute_loop_select"                value="1" />
-    <parameter name="size_re_order_buffer"                  value="64"/>
-    <parameter name="nb_re_order_buffer_bank"               value="64" />
+    <parameter name="size_re_order_buffer"                  value="1" />
+    <parameter name="nb_re_order_buffer_bank"               value="1" />
     <parameter name="commit_priority"                       value="1" />
     <parameter name="commit_load_balancing"                 value="1" />
-    <parameter name="size_issue_queue"                      value="8" />
-    <parameter name="nb_issue_queue_bank"                   value="4" />
+    <parameter name="size_issue_queue"                      value="1" />
+    <parameter name="nb_issue_queue_bank"                   value="1" />
     <parameter name="issue_queue_scheme"                    value="0" />
     <parameter name="issue_priority"                        value="1" />
     <parameter name="issue_load_balancing"                  value="1" />
-    <parameter name="size_reexecute_queue"                  value="4" />
+    <parameter name="size_reexecute_queue"                  value="1" />
     <parameter name="reexecute_priority"                    value="1" />
     <parameter name="reexecute_load_balancing"              value="1" />
@@ -139,15 +123,22 @@
 
   <execute_loop id="0">
-    <parameter name="nb_read_unit"                          value="4" />
-    <parameter name="nb_write_unit"                         value="7" />
-    <parameter name="nb_execute_unit"                       value="4" />
+    <parameter name="nb_read_unit"                          value="1" />
+    <parameter name="nb_write_unit"                         value="1" />
     <parameter name="nb_gpr_bank"                           value="1" />
-    <parameter name="nb_gpr_port_read_by_bank"              value="8" />
-    <parameter name="nb_gpr_port_write_by_bank"             value="4" />
+    <parameter name="nb_gpr_port_read_by_bank"              value="1" />
+    <parameter name="nb_gpr_port_write_by_bank"             value="1" />
     <parameter name="nb_spr_bank"                           value="1" />
-    <parameter name="nb_spr_port_read_by_bank"              value="4" />
-    <parameter name="nb_spr_port_write_by_bank"             value="4" />
+    <parameter name="nb_spr_port_read_by_bank"              value="1" />
+    <parameter name="nb_spr_port_write_by_bank"             value="1" />
     <parameter name="execution_unit_to_write_unit_priority" value="1" />
     <parameter name="read_unit_to_execution_unit_priority"  value="1" />
+
+    <execute_unit id="1">
+      <link name="link_execute_unit_with_load_store_unit"   src="0"/>
+    </execute_unit>
+    <execute_unit id="0">
+      <link name="link_execute_unit_with_functionnal_unit"  src="0"/>
+    </execute_unit>
+
   </execute_loop>
 
@@ -168,22 +159,8 @@
   <link name="link_rename_unit_with_rename_bloc"       src="0"     dest="0.0" />
   <link name="link_read_unit_with_read_bloc"           src="0"     dest="0.0" />
-  <link name="link_read_unit_with_read_bloc"           src="1"     dest="0.1" />
-  <link name="link_read_unit_with_read_bloc"           src="2"     dest="0.2" />
-  <link name="link_read_unit_with_read_bloc"           src="3"     dest="0.3" />
   <link name="link_write_unit_with_write_bloc"         src="0"     dest="0.0" />
-  <link name="link_write_unit_with_write_bloc"         src="1"     dest="0.1" />
-  <link name="link_write_unit_with_write_bloc"         src="2"     dest="0.2" />
-  <link name="link_write_unit_with_write_bloc"         src="3"     dest="0.3" />
-  <link name="link_write_unit_with_write_bloc"         src="4"     dest="0.4" />
-  <link name="link_write_unit_with_write_bloc"         src="5"     dest="0.5" />
-  <link name="link_write_unit_with_write_bloc"         src="6"     dest="0.6" />
   <link name="link_decod_bloc_with_thread"             src="0"     dest="0"   />
   <link name="link_rename_bloc_with_front_end"         src="0"     dest="0"   />
   <link name="link_load_store_unit_with_thread"        src="0"     dest="0"   />
-
-  <link name="link_execute_unit_with_load_store_unit"  src="0"     dest="0.0"/>
-  <link name="link_execute_unit_with_functionnal_unit" src="0"     dest="0.1"/>
-  <link name="link_execute_unit_with_functionnal_unit" src="1"     dest="0.2"/>
-  <link name="link_execute_unit_with_functionnal_unit" src="2"     dest="0.3"/>
 
   <link name="link_icache_port_with_thread"            src="0"     dest="0"   />
@@ -191,71 +168,9 @@
 
   <link name="table_dispatch"                          src="0.0.0" dest="1"   />
-  <link name="table_dispatch"                          src="0.1.0" dest="0"   />
-  <link name="table_dispatch"                          src="0.2.0" dest="0"   />
-  <link name="table_dispatch"                          src="0.3.0" dest="0"   />
-
-  <link name="table_dispatch"                          src="0.0.1" dest="0"   />
-  <link name="table_dispatch"                          src="0.1.1" dest="1"   />
-  <link name="table_dispatch"                          src="0.2.1" dest="0"   />
-  <link name="table_dispatch"                          src="0.3.1" dest="0"   />
-
-  <link name="table_dispatch"                          src="0.0.2" dest="0"   />
-  <link name="table_dispatch"                          src="0.1.2" dest="0"   />
-  <link name="table_dispatch"                          src="0.2.2" dest="1"   />
-  <link name="table_dispatch"                          src="0.3.2" dest="0"   />
-
-  <link name="table_dispatch"                          src="0.0.3" dest="0"   />
-  <link name="table_dispatch"                          src="0.1.3" dest="0"   />
-  <link name="table_dispatch"                          src="0.2.3" dest="0"   />
-  <link name="table_dispatch"                          src="0.3.3" dest="1"   />
-
   <link name="link_read_bloc_and_load_store_unit"      src="0.0"   dest="1"   />
-  <link name="link_read_bloc_and_load_store_unit"      src="1.0"   dest="0"   />
-  <link name="link_read_bloc_and_load_store_unit"      src="2.0"   dest="0"   />
-  <link name="link_read_bloc_and_load_store_unit"      src="3.0"   dest="0"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="0.0"   dest="0"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="1.0"   dest="1"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="2.0"   dest="1"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="3.0"   dest="0"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="0.1"   dest="0"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="1.1"   dest="1"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="2.1"   dest="1"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="3.1"   dest="0"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="0.2"   dest="0"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="1.2"   dest="0"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="2.2"   dest="0"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="3.2"   dest="1"   />
+  <link name="link_read_bloc_and_functionnal_unit"     src="0.0"   dest="1"   />
   <link name="link_write_bloc_and_load_store_unit"     src="0.0"   dest="1"   />
-  <link name="link_write_bloc_and_load_store_unit"     src="1.0"   dest="1"   />
-  <link name="link_write_bloc_and_load_store_unit"     src="2.0"   dest="0"   />
-  <link name="link_write_bloc_and_load_store_unit"     src="3.0"   dest="0"   />
-  <link name="link_write_bloc_and_load_store_unit"     src="4.0"   dest="0"   />
-  <link name="link_write_bloc_and_load_store_unit"     src="5.0"   dest="0"   />
-  <link name="link_write_bloc_and_load_store_unit"     src="6.0"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="0.0"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="1.0"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="2.0"   dest="1"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="3.0"   dest="1"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="4.0"   dest="1"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="5.0"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="6.0"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="0.1"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="1.1"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="2.1"   dest="1"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="3.1"   dest="1"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="4.1"   dest="1"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="5.1"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="6.1"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="0.2"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="1.2"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="2.2"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="3.2"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="4.2"   dest="0"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="5.2"   dest="1"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="6.2"   dest="1"   />
-
+  <link name="link_write_bloc_and_functionnal_unit"    src="0.0"   dest="1"   />
   <link name="link_thread_and_functionnal_unit"        src="0.0"   dest="1"   />
-  <link name="link_thread_and_functionnal_unit"        src="0.1"   dest="1"   />
-  <link name="link_thread_and_functionnal_unit"        src="0.2"   dest="1"   />
 
 </core>