Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/SelfTest/src/test.cpp	(revision 113)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/SelfTest/src/test.cpp	(revision 117)
@@ -63,23 +63,25 @@
   sc_signal<Tcontrol_t        >   **  in_INSERT_VAL               ;//[nb_inst_insert]
   sc_signal<Tcontrol_t        >   ** out_INSERT_ACK               ;//[nb_inst_insert]
-  sc_signal<Tcontrol_t        >   **  in_INSERT_READ_RA           ;//[nb_inst_insert]
-  sc_signal<Tgeneral_address_t>   **  in_INSERT_NUM_REG_RA_PHY    ;//[nb_inst_insert]
-  sc_signal<Tcontrol_t        >   **  in_INSERT_READ_RB           ;//[nb_inst_insert]
-  sc_signal<Tgeneral_address_t>   **  in_INSERT_NUM_REG_RB_PHY    ;//[nb_inst_insert]
-  sc_signal<Tcontrol_t        >   **  in_INSERT_READ_RC           ;//[nb_inst_insert]
-  sc_signal<Tspecial_address_t>   **  in_INSERT_NUM_REG_RC_PHY    ;//[nb_inst_insert]
+//sc_signal<Tcontrol_t        >   **  in_INSERT_READ_RA           ;//[nb_inst_insert]
+//sc_signal<Tgeneral_address_t>   **  in_INSERT_NUM_REG_RA_PHY    ;//[nb_inst_insert]
+//sc_signal<Tcontrol_t        >   **  in_INSERT_READ_RB           ;//[nb_inst_insert]
+//sc_signal<Tgeneral_address_t>   **  in_INSERT_NUM_REG_RB_PHY    ;//[nb_inst_insert]
+//sc_signal<Tcontrol_t        >   **  in_INSERT_READ_RC           ;//[nb_inst_insert]
+//sc_signal<Tspecial_address_t>   **  in_INSERT_NUM_REG_RC_PHY    ;//[nb_inst_insert]
   sc_signal<Tcontrol_t        >   **  in_INSERT_WRITE_RD          ;//[nb_inst_insert]
+  sc_signal<Tgeneral_address_t>   **  in_INSERT_NUM_REG_RD_PHY_OLD;//[nb_inst_insert]
   sc_signal<Tgeneral_address_t>   **  in_INSERT_NUM_REG_RD_PHY_NEW;//[nb_inst_insert]
   sc_signal<Tcontrol_t        >   **  in_INSERT_WRITE_RE          ;//[nb_inst_insert]
+  sc_signal<Tspecial_address_t>   **  in_INSERT_NUM_REG_RE_PHY_OLD;//[nb_inst_insert]
   sc_signal<Tspecial_address_t>   **  in_INSERT_NUM_REG_RE_PHY_NEW;//[nb_inst_insert]
   sc_signal<Tcontrol_t        >   **  in_RETIRE_VAL               ;//[nb_inst_retire]
   sc_signal<Tcontrol_t        >   ** out_RETIRE_ACK               ;//[nb_inst_retire]
   sc_signal<Tcontrol_t        >   **  in_RETIRE_RESTORE           ;//[nb_inst_retire]
-  sc_signal<Tcontrol_t        >   **  in_RETIRE_READ_RA           ;//[nb_inst_retire]
-  sc_signal<Tgeneral_address_t>   **  in_RETIRE_NUM_REG_RA_PHY    ;//[nb_inst_retire]
-  sc_signal<Tcontrol_t        >   **  in_RETIRE_READ_RB           ;//[nb_inst_retire]
-  sc_signal<Tgeneral_address_t>   **  in_RETIRE_NUM_REG_RB_PHY    ;//[nb_inst_retire]
-  sc_signal<Tcontrol_t        >   **  in_RETIRE_READ_RC           ;//[nb_inst_retire]
-  sc_signal<Tspecial_address_t>   **  in_RETIRE_NUM_REG_RC_PHY    ;//[nb_inst_retire]
+//sc_signal<Tcontrol_t        >   **  in_RETIRE_READ_RA           ;//[nb_inst_retire]
+//sc_signal<Tgeneral_address_t>   **  in_RETIRE_NUM_REG_RA_PHY    ;//[nb_inst_retire]
+//sc_signal<Tcontrol_t        >   **  in_RETIRE_READ_RB           ;//[nb_inst_retire]
+//sc_signal<Tgeneral_address_t>   **  in_RETIRE_NUM_REG_RB_PHY    ;//[nb_inst_retire]
+//sc_signal<Tcontrol_t        >   **  in_RETIRE_READ_RC           ;//[nb_inst_retire]
+//sc_signal<Tspecial_address_t>   **  in_RETIRE_NUM_REG_RC_PHY    ;//[nb_inst_retire]
   sc_signal<Tcontrol_t        >   **  in_RETIRE_WRITE_RD          ;//[nb_inst_retire]
   sc_signal<Tcontrol_t        >   **  in_RETIRE_RESTORE_RD_PHY_OLD;//[nb_inst_retire]
@@ -99,23 +101,25 @@
   ALLOC1_SC_SIGNAL( in_INSERT_VAL               ," in_INSERT_VAL               ",Tcontrol_t        ,_param->_nb_inst_insert);
   ALLOC1_SC_SIGNAL(out_INSERT_ACK               ,"out_INSERT_ACK               ",Tcontrol_t        ,_param->_nb_inst_insert);
-  ALLOC1_SC_SIGNAL( in_INSERT_READ_RA           ," in_INSERT_READ_RA           ",Tcontrol_t        ,_param->_nb_inst_insert);
-  ALLOC1_SC_SIGNAL( in_INSERT_NUM_REG_RA_PHY    ," in_INSERT_NUM_REG_RA_PHY    ",Tgeneral_address_t,_param->_nb_inst_insert);
-  ALLOC1_SC_SIGNAL( in_INSERT_READ_RB           ," in_INSERT_READ_RB           ",Tcontrol_t        ,_param->_nb_inst_insert);
-  ALLOC1_SC_SIGNAL( in_INSERT_NUM_REG_RB_PHY    ," in_INSERT_NUM_REG_RB_PHY    ",Tgeneral_address_t,_param->_nb_inst_insert);
-  ALLOC1_SC_SIGNAL( in_INSERT_READ_RC           ," in_INSERT_READ_RC           ",Tcontrol_t        ,_param->_nb_inst_insert);
-  ALLOC1_SC_SIGNAL( in_INSERT_NUM_REG_RC_PHY    ," in_INSERT_NUM_REG_RC_PHY    ",Tspecial_address_t,_param->_nb_inst_insert);
+//ALLOC1_SC_SIGNAL( in_INSERT_READ_RA           ," in_INSERT_READ_RA           ",Tcontrol_t        ,_param->_nb_inst_insert);
+//ALLOC1_SC_SIGNAL( in_INSERT_NUM_REG_RA_PHY    ," in_INSERT_NUM_REG_RA_PHY    ",Tgeneral_address_t,_param->_nb_inst_insert);
+//ALLOC1_SC_SIGNAL( in_INSERT_READ_RB           ," in_INSERT_READ_RB           ",Tcontrol_t        ,_param->_nb_inst_insert);
+//ALLOC1_SC_SIGNAL( in_INSERT_NUM_REG_RB_PHY    ," in_INSERT_NUM_REG_RB_PHY    ",Tgeneral_address_t,_param->_nb_inst_insert);
+//ALLOC1_SC_SIGNAL( in_INSERT_READ_RC           ," in_INSERT_READ_RC           ",Tcontrol_t        ,_param->_nb_inst_insert);
+//ALLOC1_SC_SIGNAL( in_INSERT_NUM_REG_RC_PHY    ," in_INSERT_NUM_REG_RC_PHY    ",Tspecial_address_t,_param->_nb_inst_insert);
   ALLOC1_SC_SIGNAL( in_INSERT_WRITE_RD          ," in_INSERT_WRITE_RD          ",Tcontrol_t        ,_param->_nb_inst_insert);
+  ALLOC1_SC_SIGNAL( in_INSERT_NUM_REG_RD_PHY_OLD," in_INSERT_NUM_REG_RD_PHY_OLD",Tgeneral_address_t,_param->_nb_inst_insert);
   ALLOC1_SC_SIGNAL( in_INSERT_NUM_REG_RD_PHY_NEW," in_INSERT_NUM_REG_RD_PHY_NEW",Tgeneral_address_t,_param->_nb_inst_insert);
   ALLOC1_SC_SIGNAL( in_INSERT_WRITE_RE          ," in_INSERT_WRITE_RE          ",Tcontrol_t        ,_param->_nb_inst_insert);
+  ALLOC1_SC_SIGNAL( in_INSERT_NUM_REG_RE_PHY_OLD," in_INSERT_NUM_REG_RE_PHY_OLD",Tspecial_address_t,_param->_nb_inst_insert);
   ALLOC1_SC_SIGNAL( in_INSERT_NUM_REG_RE_PHY_NEW," in_INSERT_NUM_REG_RE_PHY_NEW",Tspecial_address_t,_param->_nb_inst_insert);
   ALLOC1_SC_SIGNAL( in_RETIRE_VAL               ," in_RETIRE_VAL               ",Tcontrol_t        ,_param->_nb_inst_retire);
   ALLOC1_SC_SIGNAL(out_RETIRE_ACK               ,"out_RETIRE_ACK               ",Tcontrol_t        ,_param->_nb_inst_retire);
   ALLOC1_SC_SIGNAL( in_RETIRE_RESTORE           ," in_RETIRE_RESTORE           ",Tcontrol_t        ,_param->_nb_inst_retire);
-  ALLOC1_SC_SIGNAL( in_RETIRE_READ_RA           ," in_RETIRE_READ_RA           ",Tcontrol_t        ,_param->_nb_inst_retire);
-  ALLOC1_SC_SIGNAL( in_RETIRE_NUM_REG_RA_PHY    ," in_RETIRE_NUM_REG_RA_PHY    ",Tgeneral_address_t,_param->_nb_inst_retire);
-  ALLOC1_SC_SIGNAL( in_RETIRE_READ_RB           ," in_RETIRE_READ_RB           ",Tcontrol_t        ,_param->_nb_inst_retire);
-  ALLOC1_SC_SIGNAL( in_RETIRE_NUM_REG_RB_PHY    ," in_RETIRE_NUM_REG_RB_PHY    ",Tgeneral_address_t,_param->_nb_inst_retire);
-  ALLOC1_SC_SIGNAL( in_RETIRE_READ_RC           ," in_RETIRE_READ_RC           ",Tcontrol_t        ,_param->_nb_inst_retire);
-  ALLOC1_SC_SIGNAL( in_RETIRE_NUM_REG_RC_PHY    ," in_RETIRE_NUM_REG_RC_PHY    ",Tspecial_address_t,_param->_nb_inst_retire);
+//ALLOC1_SC_SIGNAL( in_RETIRE_READ_RA           ," in_RETIRE_READ_RA           ",Tcontrol_t        ,_param->_nb_inst_retire);
+//ALLOC1_SC_SIGNAL( in_RETIRE_NUM_REG_RA_PHY    ," in_RETIRE_NUM_REG_RA_PHY    ",Tgeneral_address_t,_param->_nb_inst_retire);
+//ALLOC1_SC_SIGNAL( in_RETIRE_READ_RB           ," in_RETIRE_READ_RB           ",Tcontrol_t        ,_param->_nb_inst_retire);
+//ALLOC1_SC_SIGNAL( in_RETIRE_NUM_REG_RB_PHY    ," in_RETIRE_NUM_REG_RB_PHY    ",Tgeneral_address_t,_param->_nb_inst_retire);
+//ALLOC1_SC_SIGNAL( in_RETIRE_READ_RC           ," in_RETIRE_READ_RC           ",Tcontrol_t        ,_param->_nb_inst_retire);
+//ALLOC1_SC_SIGNAL( in_RETIRE_NUM_REG_RC_PHY    ," in_RETIRE_NUM_REG_RC_PHY    ",Tspecial_address_t,_param->_nb_inst_retire);
   ALLOC1_SC_SIGNAL( in_RETIRE_WRITE_RD          ," in_RETIRE_WRITE_RD          ",Tcontrol_t        ,_param->_nb_inst_retire);
   ALLOC1_SC_SIGNAL( in_RETIRE_RESTORE_RD_PHY_OLD," in_RETIRE_RESTORE_RD_PHY_OLD",Tcontrol_t        ,_param->_nb_inst_retire);
@@ -145,13 +149,15 @@
   INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_VAL               ,_param->_nb_inst_insert);
   INSTANCE1_SC_SIGNAL(_Stat_List_unit,out_INSERT_ACK               ,_param->_nb_inst_insert);
-  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_READ_RA           ,_param->_nb_inst_insert);
-  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_NUM_REG_RA_PHY    ,_param->_nb_inst_insert);
-  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_READ_RB           ,_param->_nb_inst_insert);
-  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_NUM_REG_RB_PHY    ,_param->_nb_inst_insert);
-  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_READ_RC           ,_param->_nb_inst_insert);
-  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_NUM_REG_RC_PHY    ,_param->_nb_inst_insert);
+//INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_READ_RA           ,_param->_nb_inst_insert);
+//INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_NUM_REG_RA_PHY    ,_param->_nb_inst_insert);
+//INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_READ_RB           ,_param->_nb_inst_insert);
+//INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_NUM_REG_RB_PHY    ,_param->_nb_inst_insert);
+//INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_READ_RC           ,_param->_nb_inst_insert);
+//INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_NUM_REG_RC_PHY    ,_param->_nb_inst_insert);
   INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_WRITE_RD          ,_param->_nb_inst_insert);
+  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_NUM_REG_RD_PHY_OLD,_param->_nb_inst_insert);
   INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_NUM_REG_RD_PHY_NEW,_param->_nb_inst_insert);
   INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_WRITE_RE          ,_param->_nb_inst_insert);
+  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_NUM_REG_RE_PHY_OLD,_param->_nb_inst_insert);
   INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_INSERT_NUM_REG_RE_PHY_NEW,_param->_nb_inst_insert);
 
@@ -159,10 +165,10 @@
   INSTANCE1_SC_SIGNAL(_Stat_List_unit,out_RETIRE_ACK               ,_param->_nb_inst_retire);
   INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_RESTORE           ,_param->_nb_inst_retire);
-  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_READ_RA           ,_param->_nb_inst_retire);
-  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_NUM_REG_RA_PHY    ,_param->_nb_inst_retire);
-  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_READ_RB           ,_param->_nb_inst_retire);
-  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_NUM_REG_RB_PHY    ,_param->_nb_inst_retire);
-  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_READ_RC           ,_param->_nb_inst_retire);
-  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_NUM_REG_RC_PHY    ,_param->_nb_inst_retire);
+//INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_READ_RA           ,_param->_nb_inst_retire);
+//INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_NUM_REG_RA_PHY    ,_param->_nb_inst_retire);
+//INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_READ_RB           ,_param->_nb_inst_retire);
+//INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_NUM_REG_RB_PHY    ,_param->_nb_inst_retire);
+//INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_READ_RC           ,_param->_nb_inst_retire);
+//INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_NUM_REG_RC_PHY    ,_param->_nb_inst_retire);
   INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_WRITE_RD          ,_param->_nb_inst_retire);
   INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_RESTORE_RD_PHY_OLD,_param->_nb_inst_retire);
@@ -348,10 +354,10 @@
 
 	      in_INSERT_VAL                [i]->write((rand()%100) < percent_transaction_insert);
-	      in_INSERT_READ_RA            [i]->write(read_ra );
-	      in_INSERT_NUM_REG_RA_PHY     [i]->write(ra);
-	      in_INSERT_READ_RB            [i]->write(read_rb );
-	      in_INSERT_NUM_REG_RB_PHY     [i]->write(rb);
-	      in_INSERT_READ_RC            [i]->write(read_rc );
-	      in_INSERT_NUM_REG_RC_PHY     [i]->write(rc);
+// 	      in_INSERT_READ_RA            [i]->write(read_ra );
+// 	      in_INSERT_NUM_REG_RA_PHY     [i]->write(ra);
+// 	      in_INSERT_READ_RB            [i]->write(read_rb );
+// 	      in_INSERT_NUM_REG_RB_PHY     [i]->write(rb);
+// 	      in_INSERT_READ_RC            [i]->write(read_rc );
+// 	      in_INSERT_NUM_REG_RC_PHY     [i]->write(rc);
 	      in_INSERT_WRITE_RD           [i]->write(write_rd);
 	      in_INSERT_NUM_REG_RD_PHY_NEW [i]->write(rd);
@@ -394,11 +400,11 @@
 
 	      in_RETIRE_VAL                [i]->write((rand()%100) < percent_transaction_retire);
-	      in_RETIRE_READ_RA            [i]->write(read_ra );
-	      in_RETIRE_RESTORE            [i]->write(0);
- 	      in_RETIRE_NUM_REG_RA_PHY     [i]->write(ra);
-	      in_RETIRE_READ_RB            [i]->write(read_rb );
-	      in_RETIRE_NUM_REG_RB_PHY     [i]->write(rb);
-	      in_RETIRE_READ_RC            [i]->write(read_rc );
-	      in_RETIRE_NUM_REG_RC_PHY     [i]->write(rc);
+// 	      in_RETIRE_READ_RA            [i]->write(read_ra );
+// 	      in_RETIRE_RESTORE            [i]->write(0);
+//  	      in_RETIRE_NUM_REG_RA_PHY     [i]->write(ra);
+// 	      in_RETIRE_READ_RB            [i]->write(read_rb );
+// 	      in_RETIRE_NUM_REG_RB_PHY     [i]->write(rb);
+// 	      in_RETIRE_READ_RC            [i]->write(read_rc );
+// 	      in_RETIRE_NUM_REG_RC_PHY     [i]->write(rc);
 	      in_RETIRE_WRITE_RD           [i]->write(write_rd);
 	      in_RETIRE_RESTORE_RD_PHY_OLD [i]->write(0);
@@ -454,32 +460,32 @@
 	      if (in_INSERT_VAL [i]->read() and out_INSERT_ACK [i]->read())
 		{
-		  Tcontrol_t         read_ra  = in_INSERT_READ_RA            [i]->read();
-		  Tgeneral_address_t ra       = in_INSERT_NUM_REG_RA_PHY     [i]->read();
-		  Tcontrol_t         read_rb  = in_INSERT_READ_RB            [i]->read();
-		  Tgeneral_address_t rb       = in_INSERT_NUM_REG_RB_PHY     [i]->read();
-		  Tcontrol_t         read_rc  = in_INSERT_READ_RC            [i]->read();
-		  Tspecial_address_t rc       = in_INSERT_NUM_REG_RC_PHY     [i]->read();
+// 		  Tcontrol_t         read_ra  = in_INSERT_READ_RA            [i]->read();
+// 		  Tgeneral_address_t ra       = in_INSERT_NUM_REG_RA_PHY     [i]->read();
+// 		  Tcontrol_t         read_rb  = in_INSERT_READ_RB            [i]->read();
+// 		  Tgeneral_address_t rb       = in_INSERT_NUM_REG_RB_PHY     [i]->read();
+// 		  Tcontrol_t         read_rc  = in_INSERT_READ_RC            [i]->read();
+// 		  Tspecial_address_t rc       = in_INSERT_NUM_REG_RC_PHY     [i]->read();
 		  Tgeneral_address_t rd_new   = in_INSERT_NUM_REG_RD_PHY_NEW [i]->read();
 		  Tspecial_address_t re_new   = in_INSERT_NUM_REG_RE_PHY_NEW [i]->read();		
 		  
 		  LABEL("INSERT [%d] - Accepted",i);
-		  LABEL(" * read_ra          : %d",read_ra );
-		  LABEL(" * reg_ra           : %d",ra      );
-		  LABEL("   * status[%d]._is_free  : %d",ra,spr_status[ra]._is_free );
-		  LABEL("   * status[%d]._is_link  : %d",ra,spr_status[ra]._is_link );
-		  LABEL("   * status[%d]._is_valid : %d",ra,spr_status[ra]._is_valid);
-		  LABEL("   * status[%d]._counter  : %d",ra,spr_status[ra]._counter );
-		  LABEL(" * read_rb          : %d",read_rb );
-		  LABEL(" * reg_rb           : %d",rb      );
-		  LABEL("   * status[%d]._is_free  : %d",rb,spr_status[rb]._is_free );
-		  LABEL("   * status[%d]._is_link  : %d",rb,spr_status[rb]._is_link );
-		  LABEL("   * status[%d]._is_valid : %d",rb,spr_status[rb]._is_valid);
-		  LABEL("   * status[%d]._counter  : %d",rb,spr_status[rb]._counter );
-		  LABEL(" * read_rc          : %d",read_rc );
-		  LABEL(" * reg_rc           : %d",rc      );
-		  LABEL("   * status[%d]._is_free  : %d",rc,spr_status[rc]._is_free );
-		  LABEL("   * status[%d]._is_link  : %d",rc,spr_status[rc]._is_link );
-		  LABEL("   * status[%d]._is_valid : %d",rc,spr_status[rc]._is_valid);
-		  LABEL("   * status[%d]._counter  : %d",rc,spr_status[rc]._counter );
+// 		  LABEL(" * read_ra          : %d",read_ra );
+// 		  LABEL(" * reg_ra           : %d",ra      );
+// 		  LABEL("   * status[%d]._is_free  : %d",ra,spr_status[ra]._is_free );
+// 		  LABEL("   * status[%d]._is_link  : %d",ra,spr_status[ra]._is_link );
+// 		  LABEL("   * status[%d]._is_valid : %d",ra,spr_status[ra]._is_valid);
+// 		  LABEL("   * status[%d]._counter  : %d",ra,spr_status[ra]._counter );
+// 		  LABEL(" * read_rb          : %d",read_rb );
+// 		  LABEL(" * reg_rb           : %d",rb      );
+// 		  LABEL("   * status[%d]._is_free  : %d",rb,spr_status[rb]._is_free );
+// 		  LABEL("   * status[%d]._is_link  : %d",rb,spr_status[rb]._is_link );
+// 		  LABEL("   * status[%d]._is_valid : %d",rb,spr_status[rb]._is_valid);
+// 		  LABEL("   * status[%d]._counter  : %d",rb,spr_status[rb]._counter );
+// 		  LABEL(" * read_rc          : %d",read_rc );
+// 		  LABEL(" * reg_rc           : %d",rc      );
+// 		  LABEL("   * status[%d]._is_free  : %d",rc,spr_status[rc]._is_free );
+// 		  LABEL("   * status[%d]._is_link  : %d",rc,spr_status[rc]._is_link );
+// 		  LABEL("   * status[%d]._is_valid : %d",rc,spr_status[rc]._is_valid);
+// 		  LABEL("   * status[%d]._counter  : %d",rc,spr_status[rc]._counter );
 		  LABEL(" * read_rd          : %d",write_rd);
 		  LABEL(" * reg_rd_new       : %d",rd_new  );
@@ -495,16 +501,16 @@
 		  LABEL("   * status[%d]._counter  : %d",re_new,spr_status[re_new]._counter );
 		  
-		  if (read_ra)
-		    {
-		      gpr_status[ra]._counter ++;
-		    }
-		  if (read_rb)
-		    {
-		      gpr_status[rb]._counter ++;
-		    }
-		  if (read_rc)
-		    {
-		      spr_status[rc]._counter ++;
-		    }
+// 		  if (read_ra)
+// 		    {
+// 		      gpr_status[ra]._counter ++;
+// 		    }
+// 		  if (read_rb)
+// 		    {
+// 		      gpr_status[rb]._counter ++;
+// 		    }
+// 		  if (read_rc)
+// 		    {
+// 		      spr_status[rc]._counter ++;
+// 		    }
 		  if (write_rd)
 		    {
@@ -544,10 +550,10 @@
 	      {
 		Tcontrol_t         restore        = in_RETIRE_RESTORE            [i]->read();
-		Tcontrol_t         read_ra        = in_RETIRE_READ_RA            [i]->read();
-		Tgeneral_address_t ra             = in_RETIRE_NUM_REG_RA_PHY     [i]->read();
-		Tcontrol_t         read_rb        = in_RETIRE_READ_RB            [i]->read();
-		Tgeneral_address_t rb             = in_RETIRE_NUM_REG_RB_PHY     [i]->read();
-		Tcontrol_t         read_rc        = in_RETIRE_READ_RC            [i]->read();
-		Tspecial_address_t rc             = in_RETIRE_NUM_REG_RC_PHY     [i]->read();
+// 		Tcontrol_t         read_ra        = in_RETIRE_READ_RA            [i]->read();
+// 		Tgeneral_address_t ra             = in_RETIRE_NUM_REG_RA_PHY     [i]->read();
+// 		Tcontrol_t         read_rb        = in_RETIRE_READ_RB            [i]->read();
+// 		Tgeneral_address_t rb             = in_RETIRE_NUM_REG_RB_PHY     [i]->read();
+// 		Tcontrol_t         read_rc        = in_RETIRE_READ_RC            [i]->read();
+// 		Tspecial_address_t rc             = in_RETIRE_NUM_REG_RC_PHY     [i]->read();
 		Tcontrol_t         write_rd       = in_RETIRE_WRITE_RD           [i]->read();
 		Tcontrol_t         restore_rd_old = in_RETIRE_RESTORE_RD_PHY_OLD [i]->read();
@@ -561,22 +567,22 @@
 		LABEL("RETIRE [%d] - Accepted",i);
 		LABEL(" * restore          : %d",restore);
-		LABEL(" * read_ra          : %d",read_ra );
-		LABEL(" * reg_ra           : %d",ra      );
-		LABEL("   * status[%d]._is_free  : %d",ra,spr_status[ra]._is_free );
-		LABEL("   * status[%d]._is_link  : %d",ra,spr_status[ra]._is_link );
-		LABEL("   * status[%d]._is_valid : %d",ra,spr_status[ra]._is_valid);
-		LABEL("   * status[%d]._counter  : %d",ra,spr_status[ra]._counter );
-		LABEL(" * read_rb          : %d",read_rb );
-		LABEL(" * reg_rb           : %d",rb      );
-		LABEL("   * status[%d]._is_free  : %d",rb,spr_status[rb]._is_free );
-		LABEL("   * status[%d]._is_link  : %d",rb,spr_status[rb]._is_link );
-		LABEL("   * status[%d]._is_valid : %d",rb,spr_status[rb]._is_valid);
-		LABEL("   * status[%d]._counter  : %d",rb,spr_status[rb]._counter );
-		LABEL(" * read_rc          : %d",read_rc );
-		LABEL(" * reg_rc           : %d",rc      );
-		LABEL("   * status[%d]._is_free  : %d",rc,spr_status[rc]._is_free );
-		LABEL("   * status[%d]._is_link  : %d",rc,spr_status[rc]._is_link );
-		LABEL("   * status[%d]._is_valid : %d",rc,spr_status[rc]._is_valid);
-		LABEL("   * status[%d]._counter  : %d",rc,spr_status[rc]._counter );
+// 		LABEL(" * read_ra          : %d",read_ra );
+// 		LABEL(" * reg_ra           : %d",ra      );
+// 		LABEL("   * status[%d]._is_free  : %d",ra,spr_status[ra]._is_free );
+// 		LABEL("   * status[%d]._is_link  : %d",ra,spr_status[ra]._is_link );
+// 		LABEL("   * status[%d]._is_valid : %d",ra,spr_status[ra]._is_valid);
+// 		LABEL("   * status[%d]._counter  : %d",ra,spr_status[ra]._counter );
+// 		LABEL(" * read_rb          : %d",read_rb );
+// 		LABEL(" * reg_rb           : %d",rb      );
+// 		LABEL("   * status[%d]._is_free  : %d",rb,spr_status[rb]._is_free );
+// 		LABEL("   * status[%d]._is_link  : %d",rb,spr_status[rb]._is_link );
+// 		LABEL("   * status[%d]._is_valid : %d",rb,spr_status[rb]._is_valid);
+// 		LABEL("   * status[%d]._counter  : %d",rb,spr_status[rb]._counter );
+// 		LABEL(" * read_rc          : %d",read_rc );
+// 		LABEL(" * reg_rc           : %d",rc      );
+// 		LABEL("   * status[%d]._is_free  : %d",rc,spr_status[rc]._is_free );
+// 		LABEL("   * status[%d]._is_link  : %d",rc,spr_status[rc]._is_link );
+// 		LABEL("   * status[%d]._is_valid : %d",rc,spr_status[rc]._is_valid);
+// 		LABEL("   * status[%d]._counter  : %d",rc,spr_status[rc]._counter );
 		LABEL(" * read_rd          : %d",write_rd);
 		LABEL(" * restore_rd_old   : %d",restore_rd_old);
@@ -604,16 +610,16 @@
 		LABEL("   * status[%d]._counter  : %d",re_new,spr_status[re_new]._counter );
 
-		if (read_ra)
-		  {
-		    gpr_status[ra]._counter --;
-		  }
-		if (read_rb)
-		  {
-		    gpr_status[rb]._counter --;
-		  }
-		if (read_rc)
-		  {
-		    spr_status[rc]._counter --;
-		  }
+// 		if (read_ra)
+// 		  {
+// 		    gpr_status[ra]._counter --;
+// 		  }
+// 		if (read_rb)
+// 		  {
+// 		    gpr_status[rb]._counter --;
+// 		  }
+// 		if (read_rc)
+// 		  {
+// 		    spr_status[rc]._counter --;
+// 		  }
 		if (write_rd)
 		  {
@@ -721,23 +727,25 @@
   delete []  in_INSERT_VAL               ;
   delete [] out_INSERT_ACK               ;
-  delete []  in_INSERT_READ_RA           ;
-  delete []  in_INSERT_NUM_REG_RA_PHY    ;
-  delete []  in_INSERT_READ_RB           ;
-  delete []  in_INSERT_NUM_REG_RB_PHY    ;
-  delete []  in_INSERT_READ_RC           ;
-  delete []  in_INSERT_NUM_REG_RC_PHY    ;
+//delete []  in_INSERT_READ_RA           ;
+//delete []  in_INSERT_NUM_REG_RA_PHY    ;
+//delete []  in_INSERT_READ_RB           ;
+//delete []  in_INSERT_NUM_REG_RB_PHY    ;
+//delete []  in_INSERT_READ_RC           ;
+//delete []  in_INSERT_NUM_REG_RC_PHY    ;
   delete []  in_INSERT_WRITE_RD          ;
+  delete []  in_INSERT_NUM_REG_RD_PHY_OLD;
   delete []  in_INSERT_NUM_REG_RD_PHY_NEW;
   delete []  in_INSERT_WRITE_RE          ;
+  delete []  in_INSERT_NUM_REG_RE_PHY_OLD;
   delete []  in_INSERT_NUM_REG_RE_PHY_NEW;
   delete []  in_RETIRE_VAL               ;
   delete [] out_RETIRE_ACK               ;
   delete []  in_RETIRE_RESTORE           ;
-  delete []  in_RETIRE_READ_RA           ;
-  delete []  in_RETIRE_NUM_REG_RA_PHY    ;
-  delete []  in_RETIRE_READ_RB           ;
-  delete []  in_RETIRE_NUM_REG_RB_PHY    ;
-  delete []  in_RETIRE_READ_RC           ;
-  delete []  in_RETIRE_NUM_REG_RC_PHY    ;
+//delete []  in_RETIRE_READ_RA           ;
+//delete []  in_RETIRE_NUM_REG_RA_PHY    ;
+//delete []  in_RETIRE_READ_RB           ;
+//delete []  in_RETIRE_NUM_REG_RB_PHY    ;
+//delete []  in_RETIRE_READ_RC           ;
+//delete []  in_RETIRE_NUM_REG_RC_PHY    ;
   delete []  in_RETIRE_WRITE_RD          ;
   delete []  in_RETIRE_RESTORE_RD_PHY_OLD;