Index: trunk/Platforms/Test/data/IPC/average_x1_w4_3.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/average_x1_w4_3.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/average_x1_w4_3.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w4_3.cfg
+../../Softwares/Test/Test_072/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/average_x2_w1_5.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/average_x2_w1_5.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/average_x2_w1_5.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x2_w1_5.cfg
+../../Softwares/Test/Test_072/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w1_0.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w1_0.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w1_0.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w1_0.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w1_1.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w1_1.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w1_1.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w1_1.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w1_2.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w1_2.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w1_2.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w1_2.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w1_3.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w1_3.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w1_3.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w1_3.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w1_4.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w1_4.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w1_4.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w1_4.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w2_1.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w2_1.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w2_1.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w2_1.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w2_2.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w2_2.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w2_2.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w2_2.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w2_3.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w2_3.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w2_3.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w2_3.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w2_4.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w2_4.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w2_4.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w2_4.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w4_1.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w4_1.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w4_1.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w4_1.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w4_2.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w4_2.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w4_2.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w4_2.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w4_3.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w4_3.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w4_3.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w4_3.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w8_1.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w8_1.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w8_1.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w8_1.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x1_w8_2.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x1_w8_2.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x1_w8_2.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w8_2.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x2_w1_0.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x2_w1_0.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x2_w1_0.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x2_w1_0.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x2_w1_1.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x2_w1_1.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x2_w1_1.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x2_w1_1.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x2_w1_2.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x2_w1_2.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x2_w1_2.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x2_w1_2.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x2_w1_3.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x2_w1_3.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x2_w1_3.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x2_w1_3.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x2_w1_4.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x2_w1_4.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x2_w1_4.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x2_w1_4.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/max_x2_w1_5.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/max_x2_w1_5.cfg	(revision 120)
+++ trunk/Platforms/Test/data/IPC/max_x2_w1_5.cfg	(revision 120)
@@ -0,0 +1,8 @@
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
+../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
+../../IPs/systemC/processor/Morpheo/Files/Instance_x2_w1_5.cfg
+../../Softwares/Test/Test_071/bin/soft.x
+0
+0
+4096
+2
Index: trunk/Platforms/Test/data/IPC/x1_w1_0.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x1_w1_0.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w1_0.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x1_w1_1.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x1_w1_1.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w1_1.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x1_w1_2.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x1_w1_2.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w1_2.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x1_w1_3.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x1_w1_3.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w1_3.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x1_w1_4.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x1_w1_4.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w1_4.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x1_w2_1.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x1_w2_1.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w2_1.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x1_w2_2.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x1_w2_2.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w2_2.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x1_w2_3.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x1_w2_3.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w2_3.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x1_w2_4.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x1_w2_4.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w2_4.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x1_w4_1.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x1_w4_1.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w4_1.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x1_w4_2.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x1_w4_2.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w4_2.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x1_w8_1.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x1_w8_1.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w8_1.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x1_w8_2.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x1_w8_2.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x1_w8_2.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x2_w1_0.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x2_w1_0.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x2_w1_0.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x2_w1_1.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x2_w1_1.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x2_w1_1.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x2_w1_2.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x2_w1_2.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x2_w1_2.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x2_w1_3.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x2_w1_3.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x2_w1_3.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2
Index: trunk/Platforms/Test/data/IPC/x2_w1_4.cfg
===================================================================
--- trunk/Platforms/Test/data/IPC/x2_w1_4.cfg	(revision 119)
+++ 	(revision )
@@ -1,8 +1,0 @@
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.sim
-../../IPs/systemC/processor/Morpheo/Files/Morpheo.gen
-../../IPs/systemC/processor/Morpheo/Files/Instance_x2_w1_4.cfg
-../../Softwares/Test/Test_071/bin/soft.x
-0
-0
-4096
-2